/*
 * pftp -- sends files from host to host through free choosable ports
 *
 * Copyright (C) 1996-1999 Ben Schluricke
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the emplied warranty of MERCHANT-
 * ABILITY OF FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 *    Written by Ben Schluricke
 *    E-Mail:    bhor0533@lehr.chem.TU-Berlin.DE
 *
 * This program is dedicated to my girl-friend, Heather O'Rourke.
 *
 *
 */
#ifdef USE_POSIX_THREAD
#define _REENTRANT
#include <pthread.h>
#endif
#ifdef FreeBSD
#include <sys/types.h>
#include <sys/errno.h>
#endif
#if defined SunOS_SOLARIS || defined unicos
#include <fcntl.h>
#endif
#include <dirent.h>
#if defined Linux || defined NEXTSTEP
#include <sys/dir.h>
#endif
#include "main.h"

extern void set_tty(int);
extern long offset[SONAME];
extern void check_bandwidth(size_t);
static void test_the_net_write(FILE *, double *);
extern void send_udps(int, double *);
   
void sending(struct client_type  *clientstr)
{
   FILE *fp = (*statstr)->fp;
   char *hostname = (*statstr)->_HOSTNAME_;
   char **argv;
   char *bstrptr=NULL;
   char name[LONAME], *tmpname=NULL;
   size_t BUFFER_SIZE = (*statstr)->_STDIN_BUFSIZ_ ? (*statstr)->_STDIN_BUFSIZ_: DEFAULT_STRING_SIZE;
#ifdef Linux
   char bstr[BUFFER_SIZE];
#else
   char bstr[BIG_BUFSIZE];
#endif
   char fstr[BUFSIZE];
   char *sargv[HUNAME]; /* Hopefully this will be enough ;^) */
   FILE *fe=stderr;
   DIR *ff;
   double ci=0;
   int ofse=0;
   register int n, check;
   int length=0;
   int mode=0;
   int ft=0;
   int c, lastrr=0, rr=0, maxrr=BUFFER_SIZE;
   struct stat buf, lbuf;
#if defined Linux
   struct direct *dir;
#else
   struct dirent *dir;
#endif
   if ((*statstr)->QT_FRONTEND) fe = stdout;

#ifdef HP_UX
   lastrr = BUFFER_SIZE;
#endif

   if (!clientstr->is_subdir) {
      /*
       * Check if the client sends data to the daemon.  If so send
       * the destination directory and the password to the client.
       */
      if (!(*statstr)->use_udp) {
         if ((*statstr)->_PFTP_DAEMON_ && client_destdir && !(*statstr)->from) {
            int ll=0;
            char *passwd=NULL;

            if ((*statstr)->rpass) passwd = (*statstr)->rpass;
            else {
               MEM_CHECK((passwd = (char *)calloc(SONAME, sizeof(char))));
               bzero(passwd, SONAME);
               if (!(*statstr)->QT_FRONTEND) {
                  set_tty(2);
                  fprintf(stderr, "Password: "); fgets(passwd, SONAME, stdin);
                  set_tty(0);
                  fputc('\r', stderr);
               }
               else {
                  fprintf(stdout, "PASS\n");
                  fgets(passwd, SONAME, stdin);
               }
               for (ll=0; *(passwd+ll); ll++) {
                  if (*(passwd+ll) == '\n') *(passwd+ll) = '\0';
               }
            }
            fprintf(fp, "DDIR %s\nPASS %s\nGOON 1\n", client_destdir, passwd);
            bzero(passwd, SONAME);
            if (passwd) free(passwd);
            if (client_destdir) {
               free(client_destdir);
               client_destdir = NULL;
            }
         }
         else if ((data_subject || data_info) && (*statstr)->from) {
            long psize=0;
            if (data_info && !stat(data_info, &buf) && (buf.st_mode & S_IFMT) == S_IFREG) {
               FILE *fip=NULL;
               if (data_subject) {
                  sprintf(fstr, "Subject: %s\n", data_subject);
                  psize = strlen(fstr);
               }
               fprintf(fp, "._pftp_info_file 384 %ld\nH", psize+buf.st_size);
               fflush(fp);
               if (data_subject) {
                  for (check=0, length=psize, bstrptr=fstr; length; length-=check, bstrptr+=check) {
                     if ((check = fwrite(fstr, sizeof(char), length, fp)) < 0) {
                        if (slfp) fprintf(slfp, "** fwrite: %s\n", _PFTP_ERROR_ARRAY_);
                        exit(1);
                     }
                  }
               }
               if (!(fip = fopen(data_info, "r"))) {
                  if (slfp) fprintf(slfp, "** %s: %s\n", data_info, _PFTP_ERROR_ARRAY_);
                  exit(1);
               }
               if (!(*statstr)->QT_FRONTEND) {
                  if (slfp) fprintf(slfp, "* Sending message file to %s...\r", hostname);
               }
               else fprintf(stdout, "INFOFILE %ld\n", psize+buf.st_size);
               while ((n = fread(fstr, sizeof(char), DEFAULT_STRING_SIZE, fip)) > 0) {
                  for (check=0, length=n, bstrptr=fstr; length; length-=check, bstrptr+=check) {
                     if ((check = fwrite(fstr, sizeof(char), length, fp)) < 0) {
                        if (slfp) fprintf(slfp, "** fwrite: %s\n", _PFTP_ERROR_ARRAY_);
                        exit(1);
                     }
                  }
               }
               fclose(fip);
               if ((*statstr)->delete_info) unlink(data_info);
            }
            else if (data_subject) {
               sprintf(fstr, "Subject: %s", data_subject);
               psize = strlen(fstr);
               fprintf(fp, "._pftp_info_file 384 %ld\nH", psize);
               for (check=0, length=psize, bstrptr=fstr; length; length-=check, bstrptr+=check) {
                  if ((check = fwrite(fstr, sizeof(char), length, fp)) < 0) {
                     if (slfp) fprintf(slfp, "** fwrite: %s\n", _PFTP_ERROR_ARRAY_);
                     exit(1);
                  }
               }
               fflush(fp);
            }
         }
      }
      /*
       * Initialize Bandwidth if '-w' was given on command line.
       */
      if ((*statstr)->_BANDWIDTH_) check_bandwidth((size_t)0);
      if ((*statstr)->READFROMSTDIN) clientstr->argc++;
      if ((*statstr)->QT_FRONTEND) fprintf(stdout, "COMEON\n");
   }

   for (argv=clientstr->argv; --(clientstr->argc); argv++) {
      if (!(*statstr)->_STANDARD_INPUT_) {
         bzero((char *)name, LONAME);
         if (!(*statstr)->READFROMSTDIN || *argv) {
            bcopy(*argv, name, strlen(*argv));
         }
         else {
            char *sttmp = NULL;
            MEM_CHECK((sttmp = (char *)calloc(LONAME, sizeof(char))));
            if (!fgets(sttmp, LONAME, stdin)) {
               (clientstr->argc) = 1; 
               continue;
            }
            n = strlen(sttmp);
            *(sttmp+n-1) = '\0';
            bcopy(sttmp, name, n);
            ++(clientstr->argc); 
            argv--;
            free(sttmp);
         }

         /*
          * Get protection bits.
          */
         stat(name, &buf);
         if ((*statstr)->SENDMAKELINKS) lstat(name, &lbuf);
         mode = buf.st_mode;

         /*
          * Check file.
          */
         if ((*statstr)->SENDMAKELINKS && (lbuf.st_mode & S_IFMT) == S_IFLNK) {
            char linkcontents[LONAME], *tmpname=NULL;
            bzero(linkcontents, LONAME-1);
            if (readlink(name, linkcontents, LONAME) < 0) {
               if (slfp) fprintf(slfp, "** Can't read link %s.\n", name);
               if (pftplog) {
                  if ((fe = fopen(pftplog, "a"))) {
                     fprintf(fe, "** Can't read link %s.\n", name);
                     fclose(fe);
                  }
               }
               continue;
            }
            if (!(fe = fopen((*statstr)->SENDMAKELINKS, "a"))) {
               fprintf(slfp, "** %s: %s\n", (*statstr)->SENDMAKELINKS, _PFTP_ERROR_ARRAY_);
               exit(1);
            }
            if (*name == '/') tmpname = name+1;
            else tmpname = name;
            fprintf(fe, PFTPLINKPROG, linkcontents, tmpname);
            fclose(fe);
            continue;
         }
         else if (access(name, R_OK)) {
            fprintf(slfp, "** %s: %s\n", name, _PFTP_ERROR_ARRAY_);
            if (pftplog) {
               if ((fe = fopen(pftplog , "a"))) {
                  fprintf(fe, "** %s: %s\n", name, _PFTP_ERROR_ARRAY_);
                  fclose(fe);
               }
            }
            continue;
         }
         else if (!buf.st_size) {
            if (slfp) fprintf(slfp, "** File %s is empty.\n", name);
            if (pftplog) {
               if ((fe = fopen(pftplog, "a"))) {
                  fprintf(fe, "** File %s is empty.\n", name);
                  fclose(fe);
               }
            }
            continue;
         }
         else if ((*statstr)->_RECURS_ && (buf.st_mode & S_IFMT) == S_IFDIR) {
            struct client_type *tmpstr;
            MEM_CHECK((tmpstr = (struct client_type *)calloc(1, sizeof(struct client_type))));
            if ((ff = opendir(name)) == NULL) {
               fprintf(slfp, "** %s: %s\n", name, _PFTP_ERROR_ARRAY_);
               if (pftplog) {
                  if ((fe = fopen(pftplog, "a"))) {
                     fprintf(fe, "** %s: %s\n", name, _PFTP_ERROR_ARRAY_);
                     fclose(fe);
                  }
               }
               continue;
            }
            for (c = 0; (dir = readdir(ff)); c++)
            {
               if (!dir->d_ino || !strcmp(".", dir->d_name) || !strcmp("..", dir->d_name)) {
                  c--;
               }
               else {
                  MEM_CHECK((*(sargv+c) = (char *)calloc(LONAME, sizeof(char))));
                  sprintf(*(sargv+c), "%s%s%s",
                  name, *(name+strlen(name)-1) != '/'? "/": "", dir->d_name);
               }
            }
            closedir(ff);

            tmpstr->is_subdir = 1;
            tmpstr->argc = c + 1;
            tmpstr->argv = sargv;
            
            sending(tmpstr);
            free(tmpstr);
            while (c) {
               c--; 
               if (sargv[c]) free(sargv[c]);
            }
            continue;
         }
         else if ((buf.st_mode & S_IFMT) != S_IFREG) {
            if (slfp && !(*statstr)->READFROMSTDIN) fprintf(slfp, "** %s is not a regular file.\n", name);
            continue;
         }
      }
         
      /*
       * Open file for reading.
       */
      if ((*statstr)->_STANDARD_INPUT_) {
         ft = 0;
      }
      else if (!(ft = open(name, O_RDONLY))) {
         fprintf(slfp, "** %s: %s\n", name, _PFTP_ERROR_ARRAY_);
         if (pftplog) {
            if ((fe = fopen(pftplog, "a"))) {
               fprintf(fe, "** %s: %s\n", name, _PFTP_ERROR_ARRAY_);
               fclose(fe);
            }
         }
         continue;
      }
      else if (*(offset+ofse) >= 0) {
         if (lseek(ft, *(offset+ofse), 0) < 0) {
            fprintf(slfp, "** %s: %s\n", name, _PFTP_ERROR_ARRAY_);
            exit(1);
         }
         buf.st_size -= *(offset+ofse);
         ofse++;
      }

      /*
       * Send information about the file.
       */
      if (!(*statstr)->use_udp) {
         if ((*statstr)->version) {
            for (tmpname=name; *tmpname; tmpname++) {
               if (*tmpname == '\n') *tmpname = '_';
            }
         }
         else {
            for (tmpname=name; *tmpname; tmpname++) {
               if (*tmpname == ' ' || *tmpname == '\t' || *tmpname == '\n') {
                  *tmpname = '_';
               }
            }
         }
         if ((*statstr)->_STANDARD_INPUT_) {
            strcpy(name, "|"); mode = 0644; buf.st_size = 0;
         }
         fprintf(fp, "%s %d %ld\nH", name, mode, buf.st_size);
         fflush(fp);
      }

      /*
       * Read from local file and write to filter/remote
       * port unless we're sending udps.
       */
      if (slfp) {
         if (!(*statstr)->QT_FRONTEND) {
            fprintf(slfp, "* Sending %s %s to %s ...%s",
            (*statstr)->_STANDARD_INPUT_ ? "a stream": "file", 
            (*statstr)->_STANDARD_INPUT_ ? "\b": name, hostname, 
            (*statstr)->_STANDARD_INPUT_ ? "\n": "");
         }
      }
      if (!(*statstr)->use_udp) {
         if (!(*statstr)->testbsize) {
            if (!(*statstr)->_STANDARD_INPUT_) {
               (*statstr)->lol = 1;
               rr = maxrr > buf.st_size ? buf.st_size: maxrr;
#ifdef HP_UX
               if (lastrr < rr)
#else
               if (lastrr != rr)
#endif
               {
                  if (setsockopt(s, SOL_SOCKET, SO_SNDBUF, (char *)&rr, sizeof(rr)) < 0) {
                     fprintf(slfp, "** setsockopt: %s\n", _PFTP_ERROR_ARRAY_);
                     exit(1);
                  }
                  lastrr = rr;
               }
            }
            else rr = maxrr;
            if ((*statstr)->_STDIN_BUFSIZ_) {
               for (ci=0.0, n=0; (n = read(ft, bstr, rr)) > 0; ci+=(double)n) {
                  for (check=0, length=n, bstrptr=bstr; length; length-=check, bstrptr+=check) {
                     if ((check = fwrite(bstr, sizeof(char), length, fp)) < 0) {
                        if (slfp) fprintf(slfp, "** fwrite: %s\n", _PFTP_ERROR_ARRAY_);
                        exit(1);
                     }
                  }
                  /* waiting if necessary */
                  check_bandwidth(n);
               }
            }
            else {
               for (ci=0.0; (c = fgetc(stdin)) != EOF; ci++) {
                  if (fputc(c, fp) == EOF) {
                     fprintf(slfp, "** fputc: %s\n", _PFTP_ERROR_ARRAY_);
                     exit(1);
                  }
                  /* waiting if necessary */
                  check_bandwidth((size_t)1);
               }
            }
            if (!(*statstr)->_STANDARD_INPUT_) close(ft);
         }
         else test_the_net_write(fp, &ci);
      }
      else {
         if (!(*statstr)->_STANDARD_INPUT_) (*statstr)->lol = 1;
         send_udps(ft, &ci);
      }

      if (slfp) {
         fflush(slfp);
         if (!(*statstr)->QT_FRONTEND) {
            if ((ci == (double)buf.st_size) || (*statstr)->_STANDARD_INPUT_) {
               if ((*statstr)->lol) fputc(slfp == stderr ? '\r': '\n', slfp);
               fprintf(slfp, "--> %s (%.0f bytes) sent to %s.\n",
               (*statstr)->_STANDARD_INPUT_ ? "Stream": name, ci, hostname);
            }
            else {
               /*
                * Though the network buffer is probably too big.
                */
               fprintf(slfp, "** Sending %s to %s failed!\n", (*statstr)->_STANDARD_INPUT_ ? "stream": name, hostname);
               if (pftplog) {
                  if ((fe = fopen(pftplog, "a"))) {
                     fprintf(fe, "** Sending %s to %s failed!\n", (*statstr)->_STANDARD_INPUT_ ? "stream": name, hostname);
                     fclose(fe);
                  }
               }
            }
         }
         else {
            if (ci == (double)buf.st_size) fprintf(stdout, "SEND %.0f\n", ci);
            else fprintf(stdout, "ERROR\n");
         }
      }
   }
   if (!clientstr->is_subdir && (*statstr)->SENDMAKELINKS) {
      if (!stat((*statstr)->SENDMAKELINKS, &buf)) {
         if (buf.st_size > PFTPSCRIPTINITLEN) {
            /*
             * Send Link script if links were found.
             */
            if (!(fe = fopen((*statstr)->SENDMAKELINKS, "r"))) {
               fprintf(slfp, "** %s: %s\n", (*statstr)->SENDMAKELINKS, _PFTP_ERROR_ARRAY_);
               exit(1);
            }
            fprintf(fp, "%s 448 %ld\nH", PFTPMAKELINKS, buf.st_size);
            fflush(fp);
            if (!(*statstr)->QT_FRONTEND) fprintf(slfp, "* Sending link script to %s...\r", hostname);
            else fprintf(stdout, "LINKSCRIPT\n");
            while ((n = fread(bstr, sizeof(char), BUFSIZE, fe)) > 0) {
               for (check=0, length=n, bstrptr=bstr; length; length-=check, bstrptr+=check) {
                  if ((check = fwrite(bstr, sizeof(char), length, fp)) < 0) {
                     if (slfp) fprintf(slfp, "** fwrite: %s\n", _PFTP_ERROR_ARRAY_);
                     exit(1);
                  }
               }
            }
            fclose(fe);
            if (!(*statstr)->QT_FRONTEND) fprintf(slfp, "--> linking script (%ld bytes) sent to %s.\n", buf.st_size, hostname);
            else fprintf(stdout, "OK\n");
         }
         unlink((*statstr)->SENDMAKELINKS);
         free((*statstr)->SENDMAKELINKS);
         (*statstr)->SENDMAKELINKS=NULL; 
      }
   }
   if (!(*statstr)->use_udp) fflush(fp);
}


static void test_the_net_write(FILE *fp, double *bytes)
{
   double count=0, max=(*statstr)->testbsize;
   size_t bufsize = (unsigned long)(*statstr)->_STDIN_BUFSIZ_ < max ? (*statstr)->_STDIN_BUFSIZ_: max;
   register size_t nn=0;
   char *buf = malloc(bufsize*sizeof(char));
   memset(buf, 0, bufsize);
   
   for (count=max; count > 0; count-=(double)nn, check_bandwidth(nn)) {
      if (count < (double)bufsize) bufsize = (size_t)count;
      if ((nn = fwrite(buf, sizeof(char), bufsize, fp)) < 0) {
         if (slfp) fprintf(slfp, "** fwrite: %s\n", _PFTP_ERROR_ARRAY_);
         exit(1);
      }
   }
   *bytes = max - count;
   free(buf);
}
